=== modified file 'DBUS-API'
--- DBUS-API	2011-10-02 19:18:24 +0000
+++ DBUS-API	2011-11-26 23:08:17 +0000
@@ -112,7 +112,7 @@
       Disable().
    
    f) The date and time this client will be disabled, as an RFC 3339
-      string, or an empty string if this has not happened.
+      string, or an empty string if this is not scheduled.
    
    g) The date and time of the last approval request, as an RFC 3339
       string, or an empty string if this has not happened.
@@ -152,6 +152,9 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
+*** NewRequest(s: IP address)
+    A client at IP adress has asked for its password.
+
 * Copyright
 
     Copyright © 2010-2011 Teddy Hogeborn

=== modified file 'Makefile'
--- Makefile	2011-10-15 16:48:03 +0000
+++ Makefile	2011-11-26 22:22:20 +0000
@@ -26,12 +26,16 @@
 version=1.4.1
 SED=sed
 
+USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
+GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nobody || echo 65534)))
+
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
 # CONFDIR=$(DESTDIR)/etc/mandos
 # KEYDIR=$(DESTDIR)/etc/mandos/keys
 # MANDIR=$(PREFIX)/man
 # INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
+# STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 ## These settings are for a package-type install
@@ -40,6 +44,7 @@
 KEYDIR=$(DESTDIR)/etc/keys/mandos
 MANDIR=$(PREFIX)/share/man
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
+STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
@@ -230,7 +235,7 @@
 distclean: clean
 mostlyclean: clean
 maintainer-clean: clean
-	-rm --force --recursive keydir confdir
+	-rm --force --recursive keydir confdir statedir
 
 check:	all
 	./mandos --check
@@ -260,13 +265,8 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	@echo "#################################################################"
-	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
-	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
-	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
-	@echo "# server as root if you didn't also unpack and compile it thus. #"
-	@echo "#################################################################"
-	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
+	./mandos --debug --no-dbus --configdir=confdir \
+		--statedir=statedir $(SERVERARGS)
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf
@@ -277,6 +277,8 @@
 	install --mode=u=rw $< $@
 # Add a client password
 	./mandos-keygen --dir keydir --password >> $@
+statedir:
+	install --directory statedir
 
 install: install-server install-client-nokey
 
@@ -287,6 +289,8 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
+	install --directory --mode=u=rwx --owner=$(USER) \
+		--group=$(GROUP) $(STATEDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl

=== modified file 'TODO'
--- TODO	2011-11-09 11:16:17 +0000
+++ TODO	2011-11-29 04:03:46 +0000
@@ -42,8 +42,6 @@
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
   
-*** TODO /etc/mandos/clients.d/*.conf
-    Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
 ** TODO Log level option
    syslogger.setLevel(logging.WARNING)
@@ -52,8 +50,6 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Date+time on console log messages				  :BUGS:
-   Is this the default?
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given

=== modified file 'clients.conf'
--- clients.conf	2011-09-19 09:42:55 +0000
+++ clients.conf	2011-11-26 23:08:17 +0000
@@ -30,6 +30,9 @@
 # How long one approval will last.
 ;approval_duration = 1s
 
+# Whether this client is enabled by default
+;enabled = True
+
 
 ;####
 ;# Example client

=== modified file 'debian/control'
--- debian/control	2011-10-11 19:36:00 +0000
+++ debian/control	2011-11-26 20:59:56 +0000
@@ -17,7 +17,8 @@
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.7) | python-argparse
+	python-urwid, python (>=2.7) | python-argparse,
+	python-gnupginterface
 Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2010-09-15 17:33:14 +0000
+++ debian/mandos.dirs	2011-11-26 22:22:20 +0000
@@ -4,3 +4,4 @@
 etc/default
 etc/dbus-1/system.d
 usr/sbin
+var/lib/mandos

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2011-10-10 20:29:58 +0000
+++ debian/mandos.postinst	2011-11-26 22:22:20 +0000
@@ -35,11 +35,12 @@
 		--disabled-password --gecos "Mandos password system" \
 		_mandos
 	fi
+	chown _mandos:_mandos /var/lib/mandos
 	;;
-
+    
     abort-upgrade|abort-deconfigure|abort-remove)
 	;;
-
+    
     *)
 	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1

=== modified file 'mandos'
--- mandos	2011-11-09 11:16:17 +0000
+++ mandos	2011-11-27 20:06:35 +0000
@@ -63,7 +63,8 @@
 import cPickle as pickle
 import multiprocessing
 import types
-import hashlib
+import binascii
+import tempfile
 
 import dbus
 import dbus.service
@@ -74,7 +75,7 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
-import Crypto.Cipher.AES
+import GnuPGInterface
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -86,24 +87,126 @@
 
 
 version = "1.4.1"
-
-stored_state_path = "/var/lib/mandos/clients.pickle"
-
-#logger = logging.getLogger('mandos')
-logger = logging.Logger('mandos')
+stored_state_file = "clients.pickle"
+
+logger = logging.getLogger()
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = str("/dev/log")))
-syslogger.setFormatter(logging.Formatter
-                       ('Mandos [%(process)d]: %(levelname)s:'
-                        ' %(message)s'))
-logger.addHandler(syslogger)
-
-console = logging.StreamHandler()
-console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
-                                       ' %(levelname)s:'
-                                       ' %(message)s'))
-logger.addHandler(console)
+
+try:
+    if_nametoindex = (ctypes.cdll.LoadLibrary
+                      (ctypes.util.find_library("c"))
+                      .if_nametoindex)
+except (OSError, AttributeError):
+    def if_nametoindex(interface):
+        "Get an interface index the hard way, i.e. using fcntl()"
+        SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
+        with contextlib.closing(socket.socket()) as s:
+            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                struct.pack(str("16s16x"),
+                                            interface))
+        interface_index = struct.unpack(str("I"),
+                                        ifreq[16:20])[0]
+        return interface_index
+
+
+def initlogger(level=logging.WARNING):
+    """init logger and add loglevel"""
+    
+    syslogger.setFormatter(logging.Formatter
+                           ('Mandos [%(process)d]: %(levelname)s:'
+                            ' %(message)s'))
+    logger.addHandler(syslogger)
+    
+    console = logging.StreamHandler()
+    console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
+                                           ' [%(process)d]:'
+                                           ' %(levelname)s:'
+                                           ' %(message)s'))
+    logger.addHandler(console)
+    logger.setLevel(level)
+
+
+class PGPError(Exception):
+    """Exception if encryption/decryption fails"""
+    pass
+
+
+class PGPEngine(object):
+    """A simple class for OpenPGP symmetric encryption & decryption"""
+    def __init__(self):
+        self.gnupg = GnuPGInterface.GnuPG()
+        self.tempdir = tempfile.mkdtemp(prefix="mandos-")
+        self.gnupg = GnuPGInterface.GnuPG()
+        self.gnupg.options.meta_interactive = False
+        self.gnupg.options.homedir = self.tempdir
+        self.gnupg.options.extra_args.extend(['--force-mdc',
+                                              '--quiet'])
+    
+    def __enter__(self):
+        return self
+    
+    def __exit__ (self, exc_type, exc_value, traceback):
+        self._cleanup()
+        return False
+    
+    def __del__(self):
+        self._cleanup()
+    
+    def _cleanup(self):
+        if self.tempdir is not None:
+            # Delete contents of tempdir
+            for root, dirs, files in os.walk(self.tempdir,
+                                             topdown = False):
+                for filename in files:
+                    os.remove(os.path.join(root, filename))
+                for dirname in dirs:
+                    os.rmdir(os.path.join(root, dirname))
+            # Remove tempdir
+            os.rmdir(self.tempdir)
+            self.tempdir = None
+    
+    def password_encode(self, password):
+        # Passphrase can not be empty and can not contain newlines or
+        # NUL bytes.  So we prefix it and hex encode it.
+        return b"mandos" + binascii.hexlify(password)
+    
+    def encrypt(self, data, password):
+        self.gnupg.passphrase = self.password_encode(password)
+        with open(os.devnull) as devnull:
+            try:
+                proc = self.gnupg.run(['--symmetric'],
+                                      create_fhs=['stdin', 'stdout'],
+                                      attach_fhs={'stderr': devnull})
+                with contextlib.closing(proc.handles['stdin']) as f:
+                    f.write(data)
+                with contextlib.closing(proc.handles['stdout']) as f:
+                    ciphertext = f.read()
+                proc.wait()
+            except IOError as e:
+                raise PGPError(e)
+        self.gnupg.passphrase = None
+        return ciphertext
+    
+    def decrypt(self, data, password):
+        self.gnupg.passphrase = self.password_encode(password)
+        with open(os.devnull) as devnull:
+            try:
+                proc = self.gnupg.run(['--decrypt'],
+                                      create_fhs=['stdin', 'stdout'],
+                                      attach_fhs={'stderr': devnull})
+                with contextlib.closing(proc.handles['stdin'] ) as f:
+                    f.write(data)
+                with contextlib.closing(proc.handles['stdout']) as f:
+                    decrypted_plaintext = f.read()
+                proc.wait()
+            except IOError as e:
+                raise PGPError(e)
+        self.gnupg.passphrase = None
+        return decrypted_plaintext
+
+
 
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
@@ -168,10 +271,6 @@
                             .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % self.name))
         self.remove()
         try:
             self.add()
@@ -197,7 +296,7 @@
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
         self.entry_group_state_changed_match = (
             self.group.connect_to_signal(
-                'StateChanged', self .entry_group_state_changed))
+                'StateChanged', self.entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -229,7 +328,7 @@
             try:
                 self.group.Free()
             except (dbus.exceptions.UnknownMethodException,
-                    dbus.exceptions.DBusException) as e:
+                    dbus.exceptions.DBusException):
                 pass
             self.group = None
         self.remove()
@@ -269,8 +368,17 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
+class AvahiServiceToSyslog(AvahiService):
+    def rename(self):
+        """Add the new name to the syslog messages"""
+        ret = AvahiService.rename(self)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
+        return ret
 
-def _timedelta_to_milliseconds(td):
+def timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
@@ -280,7 +388,7 @@
     """A representation of a client host served by this server.
     
     Attributes:
-    _approved:   bool(); 'None' if not yet approved/disapproved
+    approved:   bool(); 'None' if not yet approved/disapproved
     approval_delay: datetime.timedelta(); Time to wait for approval
     approval_duration: datetime.timedelta(); Duration of one approval
     checker:    subprocess.Popen(); a running checker process used
@@ -304,9 +412,11 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
-    Last_checker_status: integer between 0 and 255 reflecting exit status
-                         of last checker. -1 reflect crashed checker.
-    last_enabled: datetime.datetime(); (UTC)
+
+    last_checker_status: integer between 0 and 255 reflecting exit
+                         status of last checker. -1 reflects crashed
+                         checker, or None.
+    last_enabled: datetime.datetime(); (UTC) or None
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
@@ -325,18 +435,18 @@
     
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.timeout)
+        return timedelta_to_milliseconds(self.timeout)
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.extended_timeout)
+        return timedelta_to_milliseconds(self.extended_timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.interval)
+        return timedelta_to_milliseconds(self.interval)
     
     def approval_delay_milliseconds(self):
-        return _timedelta_to_milliseconds(self.approval_delay)
+        return timedelta_to_milliseconds(self.approval_delay)
     
     def __init__(self, name = None, config=None):
         """Note: the 'checker' key in 'config' sets the
@@ -364,11 +474,14 @@
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
-        self.enabled = True
+        self.enabled = config.get("enabled", True)
         self.last_approval_request = None
-        self.last_enabled = datetime.datetime.utcnow()
+        if self.enabled:
+            self.last_enabled = datetime.datetime.utcnow()
+        else:
+            self.last_enabled = None
         self.last_checked_ok = None
-        self.last_checker_status = 0
+        self.last_checker_status = None
         self.timeout = string_to_delta(config["timeout"])
         self.extended_timeout = string_to_delta(config
                                                 ["extended_timeout"])
@@ -376,11 +489,14 @@
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
-        self.expires = datetime.datetime.utcnow() + self.timeout
+        if self.enabled:
+            self.expires = datetime.datetime.utcnow() + self.timeout
+        else:
+            self.expires = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
-        self._approved = None
+        self.approved = None
         self.approved_by_default = config.get("approved_by_default",
                                               True)
         self.approvals_pending = 0
@@ -391,20 +507,22 @@
         self.changedstate = (multiprocessing_manager
                              .Condition(multiprocessing_manager
                                         .Lock()))
-        self.client_structure = [attr for attr in self.__dict__.iterkeys() if not attr.startswith("_")]
+        self.client_structure = [attr for attr in
+                                 self.__dict__.iterkeys()
+                                 if not attr.startswith("_")]
         self.client_structure.append("client_structure")
-
-
+        
         for name, t in inspect.getmembers(type(self),
-                                          lambda obj: isinstance(obj, property)):
+                                          lambda obj:
+                                              isinstance(obj,
+                                                         property)):
             if not name.startswith("_"):
                 self.client_structure.append(name)
     
-    
+    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        self.changedstate.acquire()
-        self.changedstate.notify_all()
-        self.changedstate.release()
+        with self.changedstate:
+            self.changedstate.notify_all()
     
     def enable(self):
         """Start this client's checker and timeout hooks"""
@@ -439,7 +557,7 @@
     
     def __del__(self):
         self.disable()
-
+    
     def init_checker(self):
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
@@ -452,8 +570,7 @@
                                     self.disable))
         # Also start a new checker *right now*.
         self.start_checker()
-
-        
+    
     def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
@@ -485,7 +602,7 @@
             gobject.source_remove(self.disable_initiator_tag)
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
-                                          (_timedelta_to_milliseconds
+                                          (timedelta_to_milliseconds
                                            (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
@@ -585,52 +702,6 @@
                 raise
         self.checker = None
 
-    # Encrypts a client secret and stores it in a varible encrypted_secret
-    def encrypt_secret(self, key):
-        # Encryption-key need to be specific size, so we hash inputed key
-        hasheng = hashlib.sha256()
-        hasheng.update(key)
-        encryptionkey = hasheng.digest()
-
-        # Create validation hash so we know at decryption if it was sucessful
-        hasheng = hashlib.sha256()
-        hasheng.update(self.secret)
-        validationhash = hasheng.digest()
-
-        # Encrypt secret
-        iv = os.urandom(Crypto.Cipher.AES.block_size)
-        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
-                                        Crypto.Cipher.AES.MODE_CFB, iv)
-        ciphertext = ciphereng.encrypt(validationhash+self.secret)
-        self.encrypted_secret = (ciphertext, iv)
-
-    # Decrypt a encrypted client secret
-    def decrypt_secret(self, key):
-        # Decryption-key need to be specific size, so we hash inputed key
-        hasheng = hashlib.sha256()
-        hasheng.update(key)
-        encryptionkey = hasheng.digest()
-
-        # Decrypt encrypted secret
-        ciphertext, iv = self.encrypted_secret
-        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
-                                        Crypto.Cipher.AES.MODE_CFB, iv)
-        plain = ciphereng.decrypt(ciphertext)
-
-        # Validate decrypted secret to know if it was succesful
-        hasheng = hashlib.sha256()
-        validationhash = plain[:hasheng.digest_size]
-        secret = plain[hasheng.digest_size:]
-        hasheng.update(secret)
-
-        # if validation fails, we use key as new secret. Otherwhise, we use
-        # the decrypted secret
-        if hasheng.digest() == validationhash:
-            self.secret = secret
-        else:
-            self.secret = key
-        del self.encrypted_secret
-
 
 def dbus_service_property(dbus_interface, signature="v",
                           access="readwrite", byte_arrays=False):
@@ -754,7 +825,7 @@
         
         Note: Will not include properties with access="write".
         """
-        all = {}
+        properties = {}
         for name, prop in self._get_all_dbus_properties():
             if (interface_name
                 and interface_name != prop._dbus_interface):
@@ -765,11 +836,11 @@
                 continue
             value = prop()
             if not hasattr(value, "variant_level"):
-                all[name] = value
+                properties[name] = value
                 continue
-            all[name] = type(value)(value, variant_level=
-                                    value.variant_level+1)
-        return dbus.Dictionary(all, signature="sv")
+            properties[name] = type(value)(value, variant_level=
+                                           value.variant_level+1)
+        return dbus.Dictionary(properties, signature="sv")
     
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
@@ -826,6 +897,7 @@
     return dbus.String(dt.isoformat(),
                        variant_level=variant_level)
 
+
 class AlternateDBusNamesMetaclass(DBusObjectWithProperties
                                   .__metaclass__):
     """Applied to an empty subclass of a D-Bus object, this metaclass
@@ -923,6 +995,7 @@
                                         attribute.func_closure)))
         return type.__new__(mcs, name, bases, attr)
 
+
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -939,7 +1012,7 @@
     def __init__(self, bus = None, *args, **kwargs):
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
-
+        
         self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
@@ -956,7 +1029,7 @@
                              variant_level=1):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
-
+        
         transform_fun: Function that takes a value and a variant_level
                        and transforms it to a D-Bus type.
         dbus_name: D-Bus name of the variable
@@ -999,21 +1072,21 @@
     approval_delay = notifychangeproperty(dbus.UInt16,
                                           "ApprovalDelay",
                                           type_func =
-                                          _timedelta_to_milliseconds)
+                                          timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
         dbus.UInt16, "ApprovalDuration",
-        type_func = _timedelta_to_milliseconds)
+        type_func = timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt16, "Timeout",
                                    type_func =
-                                   _timedelta_to_milliseconds)
+                                   timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
         dbus.UInt16, "ExtendedTimeout",
-        type_func = _timedelta_to_milliseconds)
+        type_func = timedelta_to_milliseconds)
     interval = notifychangeproperty(dbus.UInt16,
                                     "Interval",
                                     type_func =
-                                    _timedelta_to_milliseconds)
+                                    timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1061,13 +1134,13 @@
         return r
     
     def _reset_approved(self):
-        self._approved = None
+        self.approved = None
         return False
     
     def approve(self, value=True):
         self.send_changedstate()
-        self._approved = value
-        gobject.timeout_add(_timedelta_to_milliseconds
+        self.approved = value
+        gobject.timeout_add(timedelta_to_milliseconds
                             (self.approval_duration),
                             self._reset_approved)
     
@@ -1116,6 +1189,14 @@
         "D-Bus signal"
         return self.need_approval()
     
+    # NeRwequest - signal
+    @dbus.service.signal(_interface, signature="s")
+    def NewRequest(self, ip):
+        """D-Bus signal
+        Is sent after a client request a password.
+        """
+        pass
+    
     ## Methods
     
     # Approve - method
@@ -1179,7 +1260,7 @@
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(_timedelta_to_milliseconds(
+            return dbus.UInt64(timedelta_to_milliseconds(
                     self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
@@ -1204,7 +1285,7 @@
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
-        return dbus.String(datetime_to_dbus(self.created))
+        return datetime_to_dbus(self.created)
     
     # LastEnabled - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1254,11 +1335,11 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = _timedelta_to_milliseconds((self
-                                                  .last_checked_ok
-                                                  + self.timeout)
-                                                 - datetime.datetime
-                                                 .utcnow())
+        time_to_die = timedelta_to_milliseconds((self
+                                                 .last_checked_ok
+                                                 + self.timeout)
+                                                - datetime.datetime
+                                                .utcnow())
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
@@ -1286,11 +1367,12 @@
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
-        # Reschedule checker run
-        gobject.source_remove(self.checker_initiator_tag)
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (value, self.start_checker))
-        self.start_checker()    # Start one now, too
+        if self.enabled:
+            # Reschedule checker run
+            gobject.source_remove(self.checker_initiator_tag)
+            self.checker_initiator_tag = (gobject.timeout_add
+                                          (value, self.start_checker))
+            self.start_checker()    # Start one now, too
     
     # Checker - property
     @dbus_service_property(_interface, signature="s",
@@ -1333,7 +1415,7 @@
             raise KeyError()
     
     def __getattribute__(self, name):
-        if(name == '_pipe'):
+        if name == '_pipe':
             return super(ProxyClient, self).__getattribute__(name)
         self._pipe.send(('getattr', name))
         data = self._pipe.recv()
@@ -1346,13 +1428,15 @@
             return func
     
     def __setattr__(self, name, value):
-        if(name == '_pipe'):
+        if name == '_pipe':
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
+
 class ClientDBusTransitional(ClientDBus):
     __metaclass__ = AlternateDBusNamesMetaclass
 
+
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
     
@@ -1426,6 +1510,10 @@
                 except KeyError:
                     return
                 
+                if self.server.use_dbus:
+                    # Emit D-Bus signal
+                    client.NewRequest(str(self.client_address))
+                
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
@@ -1440,10 +1528,10 @@
                             client.Rejected("Disabled")
                         return
                     
-                    if client._approved or not client.approval_delay:
+                    if client.approved or not client.approval_delay:
                         #We are approved or approval is disabled
                         break
-                    elif client._approved is None:
+                    elif client.approved is None:
                         logger.info("Client %s needs approval",
                                     client.name)
                         if self.server.use_dbus:
@@ -1463,7 +1551,7 @@
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
                     (client.changedstate.wait
-                     (float(client._timedelta_to_milliseconds(delay)
+                     (float(client.timedelta_to_milliseconds(delay)
                             / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
@@ -1568,7 +1656,7 @@
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
-        hex_fpr = ''.join("%02X" % ord(char) for char in fpr)
+        hex_fpr = binascii.hexlify(fpr).upper()
         return hex_fpr
 
 
@@ -1831,30 +1919,6 @@
     return timevalue
 
 
-def if_nametoindex(interface):
-    """Call the C function if_nametoindex(), or equivalent
-    
-    Note: This function cannot accept a unicode string."""
-    global if_nametoindex
-    try:
-        if_nametoindex = (ctypes.cdll.LoadLibrary
-                          (ctypes.util.find_library("c"))
-                          .if_nametoindex)
-    except (OSError, AttributeError):
-        logger.warning("Doing if_nametoindex the hard way")
-        def if_nametoindex(interface):
-            "Get an interface index the hard way, i.e. using fcntl()"
-            SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with contextlib.closing(socket.socket()) as s:
-                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack(str("16s16x"),
-                                                interface))
-            interface_index = struct.unpack(str("I"),
-                                            ifreq[16:20])[0]
-            return interface_index
-    return if_nametoindex(interface)
-
-
 def daemon(nochdir = False, noclose = False):
     """See daemon(3).  Standard BSD Unix function.
     
@@ -1916,9 +1980,11 @@
     parser.add_argument("--no-ipv6", action="store_false",
                         dest="use_ipv6", help="Do not use IPv6")
     parser.add_argument("--no-restore", action="store_false",
-                        dest="restore", help="Do not restore old state",
-                        default=True)
-
+                        dest="restore", help="Do not restore stored"
+                        " state")
+    parser.add_argument("--statedir", metavar="DIR",
+                        help="Directory to save/restore state in")
+    
     options = parser.parse_args()
     
     if options.check:
@@ -1937,6 +2003,8 @@
                         "use_dbus": "True",
                         "use_ipv6": "True",
                         "debuglevel": "",
+                        "restore": "True",
+                        "statedir": "/var/lib/mandos"
                         }
     
     # Parse config file for server-global settings
@@ -1959,7 +2027,8 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore"):
+                   "use_dbus", "use_ipv6", "debuglevel", "restore",
+                   "statedir"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -1977,6 +2046,17 @@
     debuglevel = server_settings["debuglevel"]
     use_dbus = server_settings["use_dbus"]
     use_ipv6 = server_settings["use_ipv6"]
+    stored_state_path = os.path.join(server_settings["statedir"],
+                                     stored_state_file)
+    
+    if debug:
+        initlogger(logging.DEBUG)
+    else:
+        if not debuglevel:
+            initlogger()
+        else:
+            level = getattr(logging, debuglevel.upper())
+            initlogger(level)
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
@@ -2037,14 +2117,6 @@
         if error[0] != errno.EPERM:
             raise error
     
-    if not debug and not debuglevel:
-        syslogger.setLevel(logging.WARNING)
-        console.setLevel(logging.WARNING)
-    if debuglevel:
-        level = getattr(logging, debuglevel.upper())
-        syslogger.setLevel(level)
-        console.setLevel(level)
-    
     if debug:
         # Enable all possible GnuTLS debugging
         
@@ -2092,9 +2164,10 @@
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiService(name = server_settings["servicename"],
-                           servicetype = "_mandos._tcp",
-                           protocol = protocol, bus = bus)
+    service = AvahiServiceToSyslog(name =
+                                   server_settings["servicename"],
+                                   servicetype = "_mandos._tcp",
+                                   protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings["interface"])))
@@ -2113,94 +2186,126 @@
         "approved_by_default":
             lambda section:
             client_config.getboolean(section, "approved_by_default"),
+        "enabled":
+            lambda section:
+            client_config.getboolean(section, "enabled"),
         }
     # Construct a new dict of client settings of this form:
     # { client_name: {setting_name: value, ...}, ...}
     # with exceptions for any special settings as defined above
     client_settings = dict((clientname,
                            dict((setting,
-                                 (value if setting not in special_settings
-                                  else special_settings[setting](clientname)))
-                                for setting, value in client_config.items(clientname)))
+                                 (value
+                                  if setting not in special_settings
+                                  else special_settings[setting]
+                                  (clientname)))
+                                for setting, value in
+                                client_config.items(clientname)))
                           for clientname in client_config.sections())
     
     old_client_settings = {}
     clients_data = []
-
+    
+    # Get client data and settings from last running state.
     if server_settings["restore"]:
         try:
             with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = pickle.load(stored_state)
+                clients_data, old_client_settings = (pickle.load
+                                                     (stored_state))
             os.remove(stored_state_path)
         except IOError as e:
-            logger.warning("Could not load persistant state: {0}".format(e))
+            logger.warning("Could not load persistent state: {0}"
+                           .format(e))
             if e.errno != errno.ENOENT:
                 raise
-
-    for client in clients_data:
-        client_name = client["name"]
-        
-        # Decide which value to use after restoring saved state.
-        # We have three different values: Old config file,
-        # new config file, and saved state.
-        # New config value takes precedence if it differs from old
-        # config value, otherwise use saved state.
-        for name, value in client_settings[client_name].items():
+    
+    with PGPEngine() as pgp:
+        for client in clients_data:
+            client_name = client["name"]
+            
+            # Decide which value to use after restoring saved state.
+            # We have three different values: Old config file,
+            # new config file, and saved state.
+            # New config value takes precedence if it differs from old
+            # config value, otherwise use saved state.
+            for name, value in client_settings[client_name].items():
+                try:
+                    # For each value in new config, check if it
+                    # differs from the old config value (Except for
+                    # the "secret" attribute)
+                    if (name != "secret" and
+                        value != old_client_settings[client_name]
+                        [name]):
+                        setattr(client, name, value)
+                except KeyError:
+                    pass
+            
+            # Clients who has passed its expire date can still be
+            # enabled if its last checker was sucessful.  Clients
+            # whose checker failed before we stored its state is
+            # assumed to have failed all checkers during downtime.
+            if client["enabled"] and client["last_checked_ok"]:
+                if ((datetime.datetime.utcnow()
+                     - client["last_checked_ok"])
+                    > client["interval"]):
+                    if client["last_checker_status"] != 0:
+                        client["enabled"] = False
+                    else:
+                        client["expires"] = (datetime.datetime
+                                             .utcnow()
+                                             + client["timeout"])
+            
+            client["changedstate"] = (multiprocessing_manager
+                                      .Condition
+                                      (multiprocessing_manager
+                                       .Lock()))
+            if use_dbus:
+                new_client = (ClientDBusTransitional.__new__
+                              (ClientDBusTransitional))
+                tcp_server.clients[client_name] = new_client
+                new_client.bus = bus
+                for name, value in client.iteritems():
+                    setattr(new_client, name, value)
+                client_object_name = unicode(client_name).translate(
+                    {ord("."): ord("_"),
+                     ord("-"): ord("_")})
+                new_client.dbus_object_path = (dbus.ObjectPath
+                                               ("/clients/"
+                                                + client_object_name))
+                DBusObjectWithProperties.__init__(new_client,
+                                                  new_client.bus,
+                                                  new_client
+                                                  .dbus_object_path)
+            else:
+                tcp_server.clients[client_name] = (Client.__new__
+                                                   (Client))
+                for name, value in client.iteritems():
+                    setattr(tcp_server.clients[client_name],
+                            name, value)
+            
             try:
-                # For each value in new config, check if it differs
-                # from the old config value (Except for the "secret"
-                # attribute)
-                if name != "secret" and value != old_client_settings[client_name][name]:
-                    setattr(client, name, value)
-            except KeyError:
-                pass
-
-        # Clients who has passed its expire date, can still be enabled if its
-        # last checker was sucessful. Clients who checkers failed before we
-        # stored it state is asumed to had failed checker during downtime.
-        if client["enabled"] and client["last_checked_ok"]:
-            if ((datetime.datetime.utcnow() - client["last_checked_ok"])
-                > client["interval"]):
-                if client["last_checker_status"] != 0:
-                    client["enabled"] = False
-                else:
-                    client["expires"] = datetime.datetime.utcnow() + client["timeout"]
-
-        client["changedstate"] = (multiprocessing_manager
-                                  .Condition(multiprocessing_manager
-                                             .Lock()))
-        if use_dbus:
-            new_client = ClientDBusTransitional.__new__(ClientDBusTransitional)
-            tcp_server.clients[client_name] = new_client
-            new_client.bus = bus
-            for name, value in client.iteritems():
-                setattr(new_client, name, value)
-            client_object_name = unicode(client_name).translate(
-                {ord("."): ord("_"),
-                 ord("-"): ord("_")})
-            new_client.dbus_object_path = (dbus.ObjectPath
-                                     ("/clients/" + client_object_name))
-            DBusObjectWithProperties.__init__(new_client,
-                                              new_client.bus,
-                                              new_client.dbus_object_path)
-        else:
-            tcp_server.clients[client_name] = Client.__new__(Client)
-            for name, value in client.iteritems():
-                setattr(tcp_server.clients[client_name], name, value)
-                
-        tcp_server.clients[client_name].decrypt_secret(
-            client_settings[client_name]["secret"])            
-        
+                tcp_server.clients[client_name].secret = (
+                    pgp.decrypt(tcp_server.clients[client_name]
+                                .encrypted_secret,
+                                client_settings[client_name]
+                                ["secret"]))
+            except PGPError:
+                # If decryption fails, we use secret from new settings
+                logger.debug("Failed to decrypt {0} old secret"
+                             .format(client_name))
+                tcp_server.clients[client_name].secret = (
+                    client_settings[client_name]["secret"])
+    
     # Create/remove clients based on new changes made to config
     for clientname in set(old_client_settings) - set(client_settings):
         del tcp_server.clients[clientname]
     for clientname in set(client_settings) - set(old_client_settings):
-        tcp_server.clients[clientname] = (client_class(name = clientname,
+        tcp_server.clients[clientname] = (client_class(name
+                                                       = clientname,
                                                        config =
                                                        client_settings
                                                        [clientname]))
     
-
     if not tcp_server.clients:
         logger.warning("No clients defined")
         
@@ -2288,37 +2393,45 @@
         multiprocessing.active_children()
         if not (tcp_server.clients or client_settings):
             return
-
-        # Store client before exiting. Secrets are encrypted with key based
-        # on what config file has. If config file is removed/edited, old
-        # secret will thus be unrecovable.
+        
+        # Store client before exiting. Secrets are encrypted with key
+        # based on what config file has. If config file is
+        # removed/edited, old secret will thus be unrecovable.
         clients = []
-        for client in tcp_server.clients.itervalues():
-            client.encrypt_secret(client_settings[client.name]["secret"])
-
-            client_dict = {}
-
-            # A list of attributes that will not be stored when shuting down.
-            exclude = set(("bus", "changedstate", "secret"))            
-            for name, typ in inspect.getmembers(dbus.service.Object):
-                exclude.add(name)
-                
-            client_dict["encrypted_secret"] = client.encrypted_secret
-            for attr in client.client_structure:
-                if attr not in exclude:
-                    client_dict[attr] = getattr(client, attr)
-
-            clients.append(client_dict) 
-            del client_settings[client.name]["secret"]
-            
+        with PGPEngine() as pgp:
+            for client in tcp_server.clients.itervalues():
+                key = client_settings[client.name]["secret"]
+                client.encrypted_secret = pgp.encrypt(client.secret,
+                                                      key)
+                client_dict = {}
+                
+                # A list of attributes that will not be stored when
+                # shutting down.
+                exclude = set(("bus", "changedstate", "secret"))
+                for name, typ in (inspect.getmembers
+                                  (dbus.service.Object)):
+                    exclude.add(name)
+                
+                client_dict["encrypted_secret"] = (client
+                                                   .encrypted_secret)
+                for attr in client.client_structure:
+                    if attr not in exclude:
+                        client_dict[attr] = getattr(client, attr)
+                
+                clients.append(client_dict)
+                del client_settings[client.name]["secret"]
+        
         try:
-            with os.fdopen(os.open(stored_state_path, os.O_CREAT|os.O_WRONLY|os.O_TRUNC, 0600), "wb") as stored_state:
+            with os.fdopen(os.open(stored_state_path,
+                                   os.O_CREAT|os.O_WRONLY|os.O_TRUNC,
+                                   0600), "wb") as stored_state:
                 pickle.dump((clients, client_settings), stored_state)
-        except IOError as e:
-            logger.warning("Could not save persistant state: {0}".format(e))
-            if e.errno != errno.ENOENT:
+        except (IOError, OSError) as e:
+            logger.warning("Could not save persistent state: {0}"
+                           .format(e))
+            if e.errno not in (errno.ENOENT, errno.EACCES):
                 raise
-
+        
         # Delete all clients, and settings from config
         while tcp_server.clients:
             name, client = tcp_server.clients.popitem()
@@ -2329,8 +2442,8 @@
             if use_dbus:
                 # Emit D-Bus signal
                 mandos_dbus_service.ClientRemoved(client
-                                              .dbus_object_path,
-                                              client.name)
+                                                  .dbus_object_path,
+                                                  client.name)
         client_settings.clear()
     
     atexit.register(cleanup)
@@ -2342,7 +2455,6 @@
         # Need to initiate checking of clients
         if client.enabled:
             client.init_checker()
-
     
     tcp_server.enable()
     tcp_server.server_activate()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
+++ mandos-clients.conf.xml	2011-11-26 23:08:17 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-10-10">
+<!ENTITY TIMESTAMP "2011-11-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -344,6 +344,20 @@
 	</listitem>
       </varlistentry>
       
+      <varlistentry>
+	<term><option>enabled<literal> = </literal>{ <literal
+	>1</literal> | <literal>yes</literal> |	<literal>true</literal
+	> | <literal >on</literal> | <literal>0</literal> | <literal
+	>no</literal> | <literal>false</literal> | <literal
+	>off</literal> }</option></term>
+	<listitem>
+	  <para>
+	    Whether this client should be enabled by default.  The
+	    default is <quote>true</quote>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2011-11-09 11:16:17 +0000
+++ mandos-options.xml	2011-11-26 22:22:20 +0000
@@ -85,10 +85,16 @@
     to the server if this option is turned off.  <emphasis>Only
     advanced users should consider changing this option</emphasis>.
   </para>
-
+  
   <para id="restore">
     This option controls whether the server will restore any state from
-    last time it ran. The Default is to try restore last state.
+    last time it ran. Default is to try restore last state.
+  </para>
+  
+  <para id="statedir">
+    Directory to save (and restore) state in.  Default is
+    <quote><filename
+    class="directory">/var/lib/mandos</filename></quote>.
   </para>
   
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2009-02-13 05:38:21 +0000
+++ mandos.conf	2011-11-26 22:22:20 +0000
@@ -4,33 +4,27 @@
 # These are the default values for the server, uncomment and change
 # them if needed.
 
-
 # If "interface" is set, the server will only listen to a specific
 # network interface.
 ;interface = 
 
-
 # If "address" is set, the server will only listen to a specific
 # address.  This must currently be an IPv6 address; an IPv4 address
 # can be specified using the "::FFFF:192.0.2.3" syntax.  Also, if this
 # is a link-local address, an interface should be set above.
 ;address =
 
-
 # If "port" is set, the server to bind to that port. By default, the
 # server will listen to an arbitrary port.
 ;port = 
 
-
 # If "debug" is true, the server will run in the foreground and print
 # a lot of debugging information.
 ;debug = False
 
-
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
 ;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 
-
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.
 # If there are name collisions on the same *network*, the server will
@@ -42,3 +36,9 @@
 
 # Whether to use IPv6.  (Changing this is NOT recommended.)
 ;use_ipv6 = True
+
+# Whether to restore saved state on startup
+;restore = True
+
+# The directory where state is saved
+;statedir = /var/lib/mandos

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2011-10-05 16:00:56 +0000
+++ mandos.conf.xml	2011-11-26 22:22:20 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-11-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -154,6 +154,25 @@
 	</listitem>
       </varlistentry>
       
+      <varlistentry>
+	<term><option>restore<literal> = </literal>{ <literal
+	  >1</literal> | <literal>yes</literal> | <literal
+	  >true</literal> | <literal>on</literal> | <literal
+	  >0</literal> | <literal>no</literal> | <literal
+	  >false</literal> | <literal>off</literal> }</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="restore"/>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>statedir<literal> = </literal><replaceable
+	>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
+	</listitem>
+      </varlistentry>
+      
     </variablelist>
   </refsect1>
   
@@ -198,6 +217,8 @@
 servicename = Daena
 use_dbus = False
 use_ipv6 = True
+restore = True
+statedir = /var/lib/mandos
       </programlisting>
     </informalexample>
   </refsect1>

=== modified file 'mandos.xml'
--- mandos.xml	2011-11-09 11:16:17 +0000
+++ mandos.xml	2011-11-26 22:22:20 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-11-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -96,6 +96,9 @@
       <arg><option>--no-ipv6</option></arg>
       <sbr/>
       <arg><option>--no-restore</option></arg>
+      <sbr/>
+      <arg><option>--statedir
+      <replaceable>DIRECTORY</replaceable></option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -284,6 +287,14 @@
 	  <xi:include href="mandos-options.xml" xpointer="restore"/>
 	</listitem>
       </varlistentry>
+      
+      <varlistentry>
+	<term><option>--statedir
+	<replaceable>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
+	</listitem>
+      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -478,6 +489,17 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
+	<term><filename
+	class="directory">/var/lib/mandos</filename></term>
+	<listitem>
+	  <para>
+	    Directory where persistent state will be saved.  Change
+	    this with the <option>--statedir</option> option.  See
+	    also the <option>--no-restore</option> option.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
 	<term><filename>/dev/log</filename></term>
 	<listitem>
 	  <para>
@@ -507,20 +529,12 @@
       backtrace.  This could be considered a feature.
     </para>
     <para>
-      Currently, if a client is disabled due to having timed out, the
-      server does not record this fact onto permanent storage.  This
-      has some security implications, see <xref linkend="clients"/>.
-    </para>
-    <para>
       There is no fine-grained control over logging and debug output.
     </para>
     <para>
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
-      The console log messages do not show a time stamp.
-    </para>
-    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>
@@ -539,9 +553,9 @@
     <informalexample>
       <para>
 	Run the server in debug mode, read configuration files from
-	the <filename>~/mandos</filename> directory, and use the
-	Zeroconf service name <quote>Test</quote> to not collide with
-	any other official Mandos server on this host:
+	the <filename class="directory">~/mandos</filename> directory,
+	and use the Zeroconf service name <quote>Test</quote> to not
+	collide with any other official Mandos server on this host:
       </para>
       <para>
 
@@ -596,21 +610,6 @@
 	compromised if they are gone for too long.
       </para>
       <para>
-	If a client is compromised, its downtime should be duly noted
-	by the server which would therefore disable the client.  But
-	if the server was ever restarted, it would re-read its client
-	list from its configuration file and again regard all clients
-	therein as enabled, and hence eligible to receive their
-	passwords.  Therefore, be careful when restarting servers if
-	it is suspected that a client has, in fact, been compromised
-	by parties who may now be running a fake Mandos client with
-	the keys from the non-encrypted initial <acronym>RAM</acronym>
-	image of the client host.  What should be done in that case
-	(if restarting the server program really is necessary) is to
-	stop the server program, edit the configuration file to omit
-	any suspect clients, and restart the server program.
-      </para>
-      <para>
 	For more details on client-side security, see
 	<citerefentry><refentrytitle>mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry>.

